/*
 * ope_window.c  Ver-1.00  Mar.6.2001
 * Copyright(c) Yoshitomo Murakami (ou812@milk.freemail.ne.jp)
 *
 * ơڥ졼󥦥ɥɽ
 */

#include <string.h>
#include "xenigma.h"

void ok_button_clicked(GtkWidget *widget, gpointer data);
void clr_button_clicked(GtkWidget *widget, gpointer data);

void ope_window(GtkWidget *widget, gpointer data)
{
  gchar *label1, *label2, *label3;

  GtkWidget *ope_window;
  GtkWidget *button;
  GtkWidget *table;
  GtkWidget *frame;

  if((int)data == ADD)
    {
      label1 = "Input file";
      label2 = "Output file";
      label3 = "PASSWORD(8 - 16 WORDS)";
    }
  else
    {
      label1 = "Extract file";
      label2 = "Extract path";
      label3 = "Clean";
    }

  /* ɥο */

  ope_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect_object(GTK_OBJECT(ope_window),
			    "delete_event",
			    GTK_SIGNAL_FUNC(gtk_main_quit),
			    GTK_OBJECT(ope_window));

  gtk_container_border_width(GTK_CONTAINER(ope_window), 10);

  gtk_window_set_title(GTK_WINDOW(ope_window), "xenigma/GTK+ Ver-1.00");

  /* ơ֥ */

  table = gtk_table_new(7, 3, TRUE);
  gtk_container_add(GTK_CONTAINER(ope_window), table);

  /* ɽ */

  frame = gtk_frame_new(label1);
  gtk_table_attach_defaults(GTK_TABLE(table), frame, 0, 3, 0, 2);
  gtk_widget_show(frame);

  /* ƥȥȥɽ */

  entrys->ientry = gtk_entry_new();
  gtk_table_attach_defaults(GTK_TABLE(table), entrys->ientry, 0, 2, 1, 2);
  gtk_widget_show(entrys->ientry);

  /* ȥܥɽ */

  button = gtk_button_new_with_label("...");
  gtk_table_attach_defaults(GTK_TABLE(table), button, 2, 3, 1, 2);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(file_open),
		     (gpointer)IN);
  gtk_widget_show(button);

  /* ɽ */

  frame = gtk_frame_new(label2);
  gtk_table_attach_defaults(GTK_TABLE(table), frame, 0, 3, 2, 4);
  gtk_widget_show(frame);

  /* ƥȥȥɽ */

  entrys->oentry = gtk_entry_new();
  gtk_table_attach_defaults(GTK_TABLE(table), entrys->oentry,0, 2, 3, 4);
  gtk_widget_show(entrys->oentry);

  /* ȥܥɽ */

  button = gtk_button_new_with_label("...");
  gtk_table_attach_defaults(GTK_TABLE(table), button, 2, 3, 3, 4);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(file_open),
		     (gpointer)OUT);
  gtk_widget_show(button);

  /* åܥåɽ */

  entrys->check_button = gtk_check_button_new_with_label(label3);
  gtk_table_attach_defaults(GTK_TABLE(table), entrys->check_button,
			    0, 3, 4, 5);
  gtk_widget_show(entrys->check_button);

  /* ƥȥȥɽ */

  entrys->gentry = gtk_entry_new_with_max_length(16);
  gtk_table_attach_defaults(GTK_TABLE(table), entrys->gentry, 0, 3, 5, 6);
  if((int)data == ADD)
    {
      gtk_widget_show(entrys->gentry);
    }

  /* OKܥɽ */

  button = gtk_button_new_with_label("OK");
  gtk_table_attach_defaults(GTK_TABLE(table), button, 0, 1, 6, 7);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(ok_button_clicked),
		     (gpointer)(int)data);
  gtk_widget_show(button);

  /* CANCELܥɽ */

  button = gtk_button_new_with_label("CANCEL");
  gtk_table_attach_defaults(GTK_TABLE(table), button, 1, 2, 6, 7);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(gtk_main_quit),
		     (gpointer)NULL);
  gtk_widget_show(button);

  /* CLEARܥɽ */

  button = gtk_button_new_with_label("CLEAR");
  gtk_table_attach_defaults(GTK_TABLE(table), button, 2, 3, 6, 7);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(clr_button_clicked),
		     (gpointer)(int)data);
  gtk_widget_show(button);

  /* ơ֥ȥɥɽ */

  gtk_widget_show(table);
  gtk_widget_show(ope_window);

  /* λ */

  gtk_grab_add(ope_window);
  gtk_main();
  gtk_grab_remove(ope_window);
  gtk_widget_destroy(ope_window);

  return;

}

void ok_button_clicked(GtkWidget *widget, gpointer data)
{
  char *ifile;
  char *ofile;
  char *pass;
  int pchk, cchk;
  char *null = "NULL";
  char *nostr = "";

  pchk = 0;
  cchk = 0;

  /* ƥȥȥ꤫ѿ */

  ifile = gtk_entry_get_text(GTK_ENTRY(entrys->ientry));
  ofile = gtk_entry_get_text(GTK_ENTRY(entrys->oentry));

  /* åܥåȽ */

  if((int)data == ADD && GTK_TOGGLE_BUTTON(entrys->check_button)->active)
    {
      pass = gtk_entry_get_text(GTK_ENTRY(entrys->gentry));
      if(strlen(pass) < 8)
	{
	  msgprint(1, "Password is over 8 words.");
	  gtk_entry_set_text(GTK_ENTRY(entrys->gentry), nostr);
	  return;
	}
      pchk++;
    }
  else if((int)data == EXT && GTK_TOGGLE_BUTTON(entrys->check_button)->active)
    {
      cchk++;
    }
  else if((int)data == ADD)
    {
      pass = null;
    }

  /* ƽ */

  switch((int)data)
    {
    case ADD:
      addfile(ifile,ofile,pchk,pass);
      break;

    case EXT:
      extract(cchk,ifile,ofile);
      break;

    default:
      break;
    }
}

void clr_button_clicked(GtkWidget *widget, gpointer data)
{
  gtk_entry_set_text(GTK_ENTRY(entrys->ientry), "");
  gtk_entry_set_text(GTK_ENTRY(entrys->oentry), "");
  if((int)data == ADD)
    {
      gtk_entry_set_text(GTK_ENTRY(entrys->gentry), "");
    }
}






