/*
 * scanstr.c  Ver-1.00  Mar.6.2001
 * Copyright(c) Yoshitomo Murakami (ou812@milk.freemail.ne.jp)
 *
 * ơȥ꡼ɽϤ줿ʸ
 */

#include "xenigma.h"
#include "scanstr.h"

void get_string(GtkWidget *widget, gpointer data);
void null_string(GtkWidget *widget, gpointer data);

void scanstr(char *message)
{

  GtkWidget *scanstr;
  GtkWidget *button;
  GtkWidget *label;
  GtkWidget *vbox;
  GtkWidget *hbox;

  scanstr = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect_object(GTK_OBJECT(scanstr),
			    "delete_event",
			    GTK_SIGNAL_FUNC(null_string),
			    GTK_OBJECT(scanstr));

  vbox = gtk_vbox_new(TRUE, 0);
  gtk_container_add(GTK_CONTAINER(scanstr), vbox);
  gtk_widget_show(vbox);

  /* åɽ */

  label = gtk_label_new(message);
  gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
  gtk_widget_show(label);

  /* ȥ꡼ɽ */

  entrys->gentry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(vbox), entrys->gentry, TRUE, TRUE, 0);
  gtk_entry_set_editable(GTK_ENTRY(entrys->gentry), TRUE);
  gtk_entry_set_visibility(GTK_ENTRY(entrys->gentry), FALSE);
  gtk_widget_show(entrys->gentry);

  /* ܥɽ */

  hbox = gtk_hbox_new(TRUE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
  gtk_widget_show(hbox);

  button = gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 5);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(get_string),NULL);
  gtk_widget_show(button);

  button = gtk_button_new_with_label("CANCEL");
  gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 5);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(null_string),NULL);
  gtk_widget_show(button);

  gtk_widget_show(scanstr);

  /* λ */

  gtk_grab_add(scanstr);
  gtk_main();
  gtk_grab_remove(scanstr);

  gtk_widget_hide(scanstr);

  return;

}

/* åμ */

void get_string(GtkWidget *widget, gpointer data)
{
  sstring->string = gtk_entry_get_text(GTK_ENTRY(entrys->gentry));
  return gtk_main_quit();
}

void null_string(GtkWidget *widget, gpointer data)
{
  sstring->string = "NULLNULL";
  return gtk_main_quit();
}













