/*
 * file_open.c  Ver-1.00  Mar.6.2001
 * Copyright(c) Yoshitomo Murakami (ou812@milk.freemail.ne.jp)
 *
 * ơե륻쥯ɽ
 */

#include "xenigma.h"

gint io;

void ok_cb(GtkWidget *widget, GtkFileSelection *fs);

void file_open(GtkWidget *widget, gpointer data)
{

  io = (int)data;

  entrys->fopen = gtk_file_selection_new("File select");
  gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(entrys->fopen));
  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(entrys->fopen)->ok_button),
		     "clicked", GTK_SIGNAL_FUNC(ok_cb),entrys->fopen);
  gtk_signal_connect(GTK_OBJECT
		     (GTK_FILE_SELECTION(entrys->fopen)->cancel_button),
		     "clicked", GTK_SIGNAL_FUNC(gtk_main_quit),entrys->fopen);
  gtk_widget_show(entrys->fopen);

  gtk_grab_add(entrys->fopen);
  gtk_main();
  gtk_grab_remove(entrys->fopen);
  gtk_widget_destroy(entrys->fopen);
  
  return;
}

void ok_cb(GtkWidget *widget, GtkFileSelection *fs)
{
  char *getstr;

  getstr = gtk_file_selection_get_filename(GTK_FILE_SELECTION(entrys->fopen));

  switch(io)
    {
    case IN:
      gtk_entry_set_text(GTK_ENTRY(entrys->ientry), getstr);
      break;

    case OUT:
      gtk_entry_set_text(GTK_ENTRY(entrys->oentry), getstr);
      break;

    default:
      break;
    }

  return gtk_main_quit();

}










