/*
 * main.c  Ver-1.00  Mar.6.2001
 * Copyright(c) Yoshitomo Murakami (ou812@milk.freemail.ne.jp)
 *
 * ơGUIˤץ
 */

#include "xenigma.h"
#include "scanstr.h"
#include "pixfile.h"

void quit(GtkWidget *widget, gpointer data);

/* GUIᥤ */

int main(int argc, char *argv[])
{

  GtkWidget *window;
  GtkWidget *button;
  GtkWidget *table;
  GtkWidget *frame;
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GtkStyle *style;

  gtk_set_locale();
  gtk_init(&argc, &argv);

  /* ¤ΤΥ */

  entrys = g_malloc(sizeof(str_entrys));
  sstring = malloc(sizeof(struct_string));

  /* ɥο */

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

  gtk_signal_connect(GTK_OBJECT(window), "destroy",
		     GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

  gtk_window_set_title(GTK_WINDOW(window), "xenigma/GTK+ Ver-1.00");
  
  gtk_container_border_width(GTK_CONTAINER(window), 1);

  /* ơ֥ */

  table = gtk_table_new(3, 3, TRUE);
  gtk_container_add(GTK_CONTAINER(window), table);
  gtk_table_set_col_spacings(GTK_TABLE(table), 5);

  /* ɽ */

  style = gtk_widget_get_style(window);
  pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
					&style->bg[GTK_STATE_NORMAL],
					xenigma_xpm);
  pixmapwid = gtk_pixmap_new(pixmap, mask);
  gtk_table_attach_defaults(GTK_TABLE(table), pixmapwid, 0, 3, 0, 3);
  gtk_widget_show(pixmapwid);

  /* ADDܥɽ */

  button = gtk_button_new_with_label("ADD");
  gtk_table_attach_defaults(GTK_TABLE(table), button, 0, 1, 2, 3);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(ope_window),
		     (gpointer)ADD);
  gtk_widget_show(button);

  /* EXTRACTܥɽ */

  button = gtk_button_new_with_label("EXTRACT");
  gtk_table_attach_defaults(GTK_TABLE(table), button, 1, 2, 2, 3);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(ope_window),
		     (gpointer)EXT);
  gtk_widget_show(button);

  /* QUITܥɽ */

  button = gtk_button_new_with_label("QUIT");
  gtk_table_attach_defaults(GTK_TABLE(table), button, 2, 3, 2, 3);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(quit),
		     (gpointer)NULL);
  gtk_widget_show(button);

  /* ơ֥ȥɥɽ */

  gtk_widget_show(table);
  gtk_widget_show(window);

  /* λ */

  gtk_main();
  g_free(entrys);
  free(sstring);
  return 0;

}

void quit(GtkWidget *widget, gpointer data)
{
  msgprint(0,"xenigma Ver-1.00\nCopyright(c) Yoshitomo Murakami \nMar.8.2001\nou812@milk.freemail.ne.jp");
  return gtk_main_quit();
}












