/*
 * msgprint.c  Ver-2.00  Mar.6.2001
 * Copyright(c) Yoshitomo Murakami (ou812@milk.freemail.ne.jp)
 *
 * ơåɽ
 */

#include <gtk/gtk.h>

gint yorn;

void ok_button(GtkWidget *widget, gpointer data);
void cancel_button(GtkWidget *widget, gpointer data);

int msgprint(int msgtyp, char *message)
{
  gchar *title;

  GtkWidget *dialog;
  GtkWidget *label;
  GtkWidget *button;

  dialog = gtk_dialog_new();
  gtk_signal_connect_object(GTK_OBJECT(dialog),
			    "delete_event",
			    GTK_SIGNAL_FUNC(gtk_main_quit),
			    GTK_OBJECT(dialog));

  /* åפȽ */

  if(msgtyp == 0)
    {
      title = "";
    }
  else if(msgtyp == 1)
    {
      title = "ERROR";
    }
  else
    {
      title = "WARNING";
    }

  /* ȥɽ */

  label = gtk_label_new(title);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);
  gtk_widget_show(label);

  /* åɽ */

  label = gtk_label_new(message);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);
  gtk_widget_show(label);

  /* ܥɽ */

  button = gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), button,
		     TRUE, TRUE, 5);
  gtk_signal_connect(GTK_OBJECT(button),"clicked",
		     GTK_SIGNAL_FUNC(ok_button),(gpointer)msgtyp);
  gtk_signal_connect(GTK_OBJECT(button),"clicked",
		     GTK_SIGNAL_FUNC(gtk_main_quit),(gpointer)NULL);
  gtk_widget_show(button);

  if(msgtyp >= 2)
    {
      button = gtk_button_new_with_label("CANCEL");
      gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), button,
			 TRUE, TRUE, 5);
      gtk_signal_connect(GTK_OBJECT(button),"clicked",
			 GTK_SIGNAL_FUNC(cancel_button),(gpointer)msgtyp);
      gtk_signal_connect(GTK_OBJECT(button),"clicked",
			 GTK_SIGNAL_FUNC(gtk_main_quit),(gpointer)NULL);
      gtk_widget_show(button);
    }

  gtk_widget_show(dialog);

  /* λ */

  gtk_grab_add(dialog);
  gtk_main();
  gtk_grab_remove(dialog);
  gtk_widget_destroy(dialog);

  return yorn;

}

void ok_button(GtkWidget *widget, gpointer data)
{
  if((int)data == 2)
    {
      yorn = 1;
    }
  else
    {
      yorn = 0;
    }
}

void cancel_button(GtkWidget *widget, gpointer data)
{
  yorn = 0;
}



